using Godot;
using System;

public class Player : Character
{
    bool _touchingBlock1 = false;
    bool _touchingBlock2 = false;

    private float _deltaLastJump = 0;

    public override void _Ready()
    {
        base._Ready();
    }

    // Called every frame. 'delta' is the elapsed time since the previous frame.
    public override void _Process(float delta)
    {
        base._Process(delta);

        _deltaLastJump += delta;

        ShallRunLeft = Input.IsActionPressed("move_left");
        ShallRunRight = Input.IsActionPressed("move_right");
        if (Input.IsActionPressed("jump"))
        {
            if (_deltaLastJump > 0.25 && this.IsOnFloor())
            {
                ShallJump = true;
                _deltaLastJump = 0;
            }
            else if (!this.IsJumping())
            {
                ShallJump = false;
            }
        }
        else
        {
            ShallJump = false;
        }

        GD.Print(_touchingBlock1, _touchingBlock2, IsStepping(), IsJumping());

        if (_touchingBlock1 && !_touchingBlock2 && !this.IsStepping() && !this.IsJumping() && Math.Abs(this.GetVelocity().y) < 50)
        {
            if ((this.ShallRunLeft && this.GetVelocity().x <= 0) || (this.ShallRunRight && this.GetVelocity().x >= 0))
            {
                StepOn(-50);
            }
        }
    }

    public override void _PhysicsProcess(float delta)
    {
        if (this.IsOnWall() && !IsStepping() && this._touchingBlock2)
        {
            this.SetVelocityX(0);
        };
        base._PhysicsProcess(delta);
    }
    protected override float CalcSpecialRegenerationMultiplier(float deltaDamage)
    {
        return deltaDamage < 5 ? 0 : GetVelocity().x == 0 ? 2 : 1;
    }

    public void _on_Block1Area_body_entered(Node2D body)
    {
        _touchingBlock1 = true;
    }

    public void _on_Block2Area_body_entered(Node body)
    {
        _touchingBlock2 = true;
    }

    public void _on_Block1Area_body_exited(Node body)
    {
        _touchingBlock1 = false;
    }

    public void _on_Block2Area_body_exited(Node body)
    {
        _touchingBlock2 = false;
    }
}
