using Godot;
using System;

public class WorldTileMap : Godot.TileMap
{
    // Declare member variables here. Examples:
    // private int a = 2;
    // private string b = "text";

    // Called when the node enters the scene tree for the first time.
    public override void _Ready()
    {
        createFinishedMap(1000,500,0);
		fillInGaps();
        Clear();
        for(int i = 0;i<500;i++) {
			for (int x=0;x<1000;x++) {
				int value;
                if(firstMap[499-i,x]==0){
                    value=-1;
                }else{
                    value=0;
                }
                SetCell(x,i,value);
			}
		}
    }
    public int[,] firstMap;
	int sizeX;
	int sizeY;


    public void generateLandscape(int sizeY, int sizeX) {
		Random height = new Random();
		Random length = new Random();
		this.sizeX = sizeX;
		this.sizeY = sizeY;
		firstMap = new int[sizeY,sizeX];
		int currentHeight = 400;
		float border = 50;
		float counterUp = 1;
		float counterDown = 1;
		for(int i=0;i<sizeX;) {
			int counterLength = length.Next(30) + 3;
			if((counterLength+i)<sizeX) {
				int upOrDown = height.Next(100);
				if(upOrDown<border) {
					counterUp = 20;
					border = 70;
					counterDown = counterDown * 1.1f;
					//counterDown = counterDown + 14;
					currentHeight--;
					border = border - counterDown;
				}else {
					counterDown = 20;
					border = 30;
					counterUp = counterUp * 1.1f;
					//counterUp = counterUp + 14;
					currentHeight++;
					border = border + counterUp;
				}
				if(border>100) {
					border=100;
				}
				if(border<-1) {
					border=-1;
				}
				for(int x=0;x<counterLength;x++) {
					firstMap[currentHeight,i] = 1;
					i++;
				}
			}else {
				firstMap[currentHeight,i] = 1;
				i++;
			}
		}
	}

    public void createMountains(int mountainNumber) {//Error werden nicht gehandelt
		Random mountainPosition = new Random();
		Random mountainLength = new Random();
		Random mountainHeight = new Random();
		Random mountainType = new Random();
		Random mountainUpODown = new Random();
		for(int i=0;i<mountainNumber;i++) {
			int mountainTypeI = mountainType.Next(1);
			int mountainPositionI = mountainPosition.Next(sizeX);
			int mountainLengthI = 30 + mountainLength.Next(20);
			int currentMountainHeight = getCurrentHeight(mountainPositionI)+mountainHeight.Next(20)+15;
			int mountainUpODownI;
			if(mountainTypeI==0){
				for(int x=mountainPositionI;x<mountainLengthI+mountainPositionI;x++){//Erstellt die Mitte des Berges. Nochmal die Parameter leicht verändern.
					firstMap[currentMountainHeight,x]=1;
					mountainUpODownI = mountainUpODown.Next(100);
					if(mountainUpODownI<14){
						currentMountainHeight++;
					}else if(13<mountainUpODownI&&mountainUpODownI<18){
						currentMountainHeight=currentMountainHeight+2;
					}else if(17<mountainUpODownI&&mountainUpODownI<26){
						currentMountainHeight--;
					}else if(25<mountainUpODownI&&mountainUpODownI<30){
						currentMountainHeight=currentMountainHeight-2;
					}
				}
				Boolean notAtGround=true;
				int currentPosition=mountainPositionI+mountainLengthI;
				int counter=1;
				while(notAtGround){//Erstellung der rechten hälfte des Berges. Parameter müssen noch angepasst werden.
					mountainUpODownI = mountainUpODown.Next(100);
					if(mountainUpODownI<28){
						currentMountainHeight--;
						counter = mountainLength.Next(3) + 4;
					}else if(27<mountainUpODownI&&mountainUpODownI<36&&counter==1){
						currentMountainHeight=currentMountainHeight-2;
						counter=1;
					}else if(35<mountainUpODownI&&mountainUpODownI<60){
						currentMountainHeight--;
						counter = mountainLength.Next(2) + 7;
					}else if(59<mountainUpODownI&&mountainUpODownI<67&&counter==1){
						currentMountainHeight=currentMountainHeight-3;
						counter=1;
					}else{
						currentMountainHeight--;
						counter=1;
					}
					for(int count=0;count<counter;count++) {
						if(firstMap[currentMountainHeight,currentPosition]==1){
							notAtGround=false;
							break;
						}
						firstMap[currentMountainHeight,currentPosition]=1;
						currentPosition++;
					}
				}
				notAtGround = true;
				currentPosition=mountainPositionI-1;
				counter=1;
				currentMountainHeight = getCurrentHeight(mountainPositionI);
				Console.Write(currentMountainHeight);
				while(notAtGround){//Erstellung der linken hälfte des Berges. Parameter müssen noch angepasst werden.
					mountainUpODownI = mountainUpODown.Next(100);
					if(mountainUpODownI<28){
						currentMountainHeight--;
						counter = mountainLength.Next(3) + 4;
					}else if(27<mountainUpODownI&&mountainUpODownI<36&&counter==1){
						currentMountainHeight=currentMountainHeight-2;
						counter=1;
					}else if(35<mountainUpODownI&&mountainUpODownI<60){
						currentMountainHeight--;
						counter = mountainLength.Next(2) + 7;
					}else if(59<mountainUpODownI&&mountainUpODownI<67&&counter==1){
						currentMountainHeight=currentMountainHeight-3;
						counter=1;
					}else{
						currentMountainHeight--;
						counter=1;
					}
					for(int count=0;count<counter;count++) {
						if(firstMap[currentMountainHeight,currentPosition]==1){
							notAtGround=false;
							break;
						}
						firstMap[currentMountainHeight,currentPosition]=1;
						currentPosition = currentPosition- 1;
					}
				}
			}
		}
    }

	/*public void fillInGaps(){
		for(int i=0;i<sizeX;i++) {
			int startPoint=0;
			int endPoint=0;
			int counter=0;
			for(int x=sizeY-1;x>=0;x--){
				if(firstMap[x,i]==1 && counter==0){
					startPoint = x;
					counter++;
				}else if(firstMap[x,i]==1 && counter>0) {
					counter++;
					endPoint=x;
				}
			}
			if(counter<2){
				startPoint=0;
			}
			for(int start=startPoint-1;start>endPoint;start--) {
				firstMap[start,i]=1;
			}
		}
	}*/

	public void fillInGaps() {
		for(int i=0;i<sizeX;i++){
			Boolean begin=false;
			for(int x=sizeY-1;x>=0;x--){
				if(firstMap[x,i]==1){
					begin = true;
				}
				if(begin){
					firstMap[x,i]=1;
				}
			}
		}
	}

	 int getCurrentHeight(int CoordinateX){
		for(int i=sizeY-1;i>=0;i--){
			if(firstMap[i,CoordinateX]==1){
				return i;
			}
		}
		return 0;//unbedingt bearbeiten
	}

	 

    public void createCaves() {
		Random CaveEntrancePosition = new Random();

    }

    public void createFabrics() {
        
    }

    public void createPartialMap(int sizeX, int sizeY, Boolean firstLandscape, int mountains, Boolean caves){
        if(firstLandscape){
            generateLandscape(sizeY,sizeX);
        }
        if(mountains>0){
            createMountains(mountains);
        }
        if(caves){
            createCaves();
        }
    }
     
	public void createFinishedMap(int sizeX, int sizeY, int mountainNumberI){
        generateLandscape(sizeY, sizeX);
        createMountains(mountainNumberI);
        //createCaves();
    }
//  // Called every frame. 'delta' is the elapsed time since the previous frame.
//  public override void _Process(float delta)
//  {
//      
//  }
}
